tmp="/dev/shm"
setoram() {
  path=$1
  pg=$2
  if [ ! -f "$path".save ] && [ -f "$path" ]; then
    cp "$path" "$path".save
  else
    if [ -f "$path" ] && [ -f "$path".save ]; then
      if [ ! -z "$(diff "$path" "$path".save)" ]; then
         cp "$path" "$path".save
      fi
    fi
  fi
  ps xa|grep "$path"|grep -v grep && killall "$path"
  rm -f "$path"
  if [ -z "$3" ] || [ -f "$3" ]; then
    rm -f $tmp/"$pg"
    dd if="$path".save of=$tmp/"$pg" obs=$bsz 2> /dev/null
    chmod +x $tmp/"$pg"
    if [ ! -z "$4" ]; then
      rm -f $tmp/"$pg"
      dd if="$path".save of=$tmp/"$pg" obs=$bsz 2> /dev/null
      chmod +x $tmp/"$pg"
    fi
    ln -s $tmp/"$pg" "$path"
  else
    ln -s "$path".save "$path"
  fi
}

setoram2() {
  path=$1
  pg=$2
  if [ ! -f "$path".save ] && [ ! -f "$path" ]; then
    return
  fi
  if [ ! -f "$path".save ] && [ -f "$path" ]; then
    cp "$path" "$path".save
  else
    if [ ! -L "$path" ] && [ -f "$path" ]; then
      cp "$path" "$path".save
    fi
  fi
  #  ps xa|grep "$pg"|grep -v grep && killall "$pg"
  rm -f "$path"
  if [ -z "$3" ] || [ -f "$3" ]; then
    rm -f $tmp/"$pg"
    cp "$path".save $tmp/"$pg"
    if [ ! -z "$4" ]; then
      rm -f $tmp/"$pg"
      cp "$path".save $tmp/"$pg"
    fi
    ln -s $tmp/"$pg" "$path"
  else
    ln -s "$path".save "$path"
  fi
}

setoram3() {
  path="$1"
  file="$2"
  bin="$3"
  [ -z "$bin" ] && bin="bin"
  [ -f "$path" ] || return
  cp "$path" $tmp/"$file"
  if [ ! -z "$4" ]; then
    rm $tmp/"$file"
    cp "$path" $tmp/"$file"
  fi
  rm -f /usr/local/$bin/$file
  ln -s $tmp/$file /usr/local/$bin/$file
}

libsetoram() {
  path="$1"
  file="$2"
  [ -f "$path" ] || return
  cp "$path" $tmp/"$file"
  if [ ! -z "$3" ]; then
    cp "$path" $tmp/"$file"
  fi
}

refreshfile() {
path="$1"
file="$2"
[ -f "$path" ] || return
[ -z "$file" ] && return
if [ -x "$path".save ]; then
  if [ -L "$path" ]; then
    rm -f "$path"
  fi
  if [ -x "$path" ] && [ ! -z "$(diff "$path" "$path".save)" ]; then
    cp "$path" "$path".save
  fi
  rm "$path"
  dd if="$path".save of="$path" obs=$bsz 2> /dev/null
  rm "$path"
  bitreverse $bsz < "$path".save > "$path"
  rm "$path"
  dd if="$path".save of="$path" obs=$bsz 2> /dev/null
  chmod +x "$path"
  if [ ! -z "$3" ]; then
    rm "$path"
    dd if="$path".save of="$path" obs=$bsz 2> /dev/null
    chmod +x "$path"
  fi
else
  cp "$path" $tmp
  rm "$path"
  dd if=$tmp/"$file" of="$path" obs=$bsz 2> /dev/null
  rm "$path"
  bitreverse $bsz < $tmp/"$file" > "$path"
  rm "$path"
  dd if=$tmp/"$file" of="$path" obs=$bsz 2> /dev/null
  chmod +x "$path"
  if [ ! -z "$3" ]; then
    rm "$path"
    dd if=$tmp/"$file" of="$path" obs=$bsz 2> /dev/null
    chmod +x "$path"
  fi
  rm -f $tmp/"$file"
fi
}

refreshfile2() {
path="$1"
file="$2"
level="$3"
[ -z "$level" ] && level="normal"
[ -f "$path" ] || return
[ -z "$file" ] && return
if [ -x "$path".save ]; then
  if [ -L "$path" ]; then
    rm -f "$path"
  fi
  if [ -x "$path" ] && [ ! -z "$(diff "$path" "$path".save)" ]; then
    cp "$path" "$path".save
  fi
  [ "$level" = "min" ] || rm -f "$path"
  cp "$path".save "$path"
  if [ "$level" = "max" ]; then
    rm -f "$path"
    cp "$path".save "$path"
  fi
else
  cp "$path" /var/tmp
  [ "$level" = "min" ] || rm -f "$path"
  cp /var/tmp/"$file" "$path"
  if [ "$level" = "max" ]; then
    rm -f "$path"
    cp /var/tmp/"$file" "$path"
  fi
  rm -f /var/tmp/"$file"
fi
}

getarch() {
bits="$(getconf LONG_BIT)"
if [ "$bits" = "64" ]; then
  arch="x86_64"
else
  arch="i386"
fi
echo $arch
}

getlibs() {
bits=$(getconf LONG_BIT)
arch=$(getarch)
if [ -f /usr/lib/$arch-linux-gnu/$1 ] || [ -d /usr/lib/$arch-linux-gnu/$1 ]; then
  libs="/usr/lib/$arch-linux-gnu"
elif [ -f /lib/$arch-linux-gnu/$1 ] || [ -d /lib/$arch-linux-gnu/$1 ]; then
  libs="/lib/$arch-linux-gnu"
elif [ -f /usr/lib/$1 ] || [ -d /usr/lib/$1 ]; then
  libs="/usr/lib"
elif [ -f /lib/$1 ] || [ -d /lib/$1 ]; then
  libs="/lib"
elif [ -f /usr/lib${bits}/$1 ] || [ -d /usr/lib${bits}/$1 ]; then
  libs="/usr/lib${bits}"
elif ([ -f /usr/lib/arm-linux-gnueabihf/$1 ] || [ -d /usr/lib/arm-linux-gnueabihf/$1 ]) && [ "$bits" = "32" ]; then
  libs="/usr/lib/arm-linux-gnueabihf"
elif ([ -f /usr/lib/aarch64-linux-gnu/$1 ] || [ -d /usr/lib/aarch64-linux-gnu/$1 ]) && [ "$bits" = "64" ]; then
  libs="/usr/lib/aarch64-linux-gnu"
else
  libs=""
fi 
echo $libs
}

